/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import java.util.Date;


import jp.mosp.common.CommonConst;
import jp.mosp.common.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.dao.MosPUserDao;
import jp.mosp.common.dto.CmUserDto;

import jp.mosp.system.vo.AccountMasterCardVo;

public class AccountMasterCardAction extends MosPAction {

	// コマンド
	private static final String CMD_ACCOUNT_MASTER_CARD_SHOW   = "S2405";
	private static final String CMD_ACCOUNT_MASTER_CARD_SELECT = "S2406";
	private static final String CMD_ACCOUNT_MASTER_CARD_INSERT = "S2407";
	private static final String CMD_ACCOUNT_MASTER_CARD_UPDATE = "S2408";

	/**
	 * コンストラクタ
	 */
	public AccountMasterCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// VOの取得
		AccountMasterCardVo vo = new AccountMasterCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// コードリスト取得
		/*						
		 *  	2009/01/09	k.taniai	メニューアレンジ対応
		 */
		vo.aryPltAuthority = util.combineArray(getCodeArray(CommonConst.TID_AUTHORITY), getArrangeAuthArray());
		// DTOの取得
		CmUserDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof CmUserDto ? (CmUserDto)obj : null;
		// コマンド毎の処理
		if (cmd.equals(CMD_ACCOUNT_MASTER_CARD_SHOW)) {
			vo.setDefaultValues();
		} else if (cmd.equals(CMD_ACCOUNT_MASTER_CARD_SELECT)) {
			// DAOの宣言
			MosPUserDao dao = new MosPUserDao();
			dao.initDao(cfg, cmd, aspUser, user, conn);
			// データの取得
			dto = dao.findForKey(key1);
			chkExist(dto);
			// VOに情報をセット
			vo.setFields(dto);
			setMode(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_ACCOUNT_MASTER_CARD_INSERT)) {
			// 新規登録
			dto = insert(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_ACCOUNT_MASTER_CARD_UPDATE)) {
			// 更新
			dto = update(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @throws Exception
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private CmUserDto insert(AccountMasterCardVo vo) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// DAOの準備
		MosPUserDao dao = new MosPUserDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 存在チェック
		chkDuplicate(dao.findForKey(vo.getTxtUserId()), vo);
		// DTOの準備
		CmUserDto dto = new CmUserDto();
		vo.setDtoFields(dto);
		dto.setPassword(MospUtility.getDigest(MospUtility.getDigest(dto.getUserId())));
		dto.setKCode("");
		dto.setChangePass(new Date());
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		dto = dao.findForKey(dto.getUserId());
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		return dto;
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private CmUserDto update(AccountMasterCardVo vo, CmUserDto dto) throws Exception {
		// VOのモード設定
		setMode(vo);
		// パラメータの妥当性確認
		vo.validate();
		// DAOの準備
		MosPUserDao dao = new MosPUserDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(vo.getTxtUserId()), vo);
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		dao.update(dto, true);
		// DTOの再取得
		CmUserDto retDto = dao.findForKey(dto.getUserId());
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}

	/**
	 * モード設定
	 * @param vo 対象VO
	 * @throws Exception
	 */
	private void setMode(AccountMasterCardVo vo) throws Exception {
		// モード設定
		if (hasSystemAuth()) {
			vo.setMode(AccountMasterCardVo.MODE_SYSTEM);
		} else {
			vo.setMode(AccountMasterCardVo.MODE_UPDATE);
		}
	}

}
